# A horizontal sundial with a longitude correction, text only
# www.illustratingshadows.com               # January 4, 2013

use English;
#                                           # http://perldoc.perl.org/Math/Trig.html#TRIGONOMETRIC-FUNCTIONS
use Math::Trig;                             # needs "use Math::Trig;" as "atan2" is worthless
                                            # also TAN is in math.trig, otherwise you must
                                            # do sin/cos. But the big deal is TAN vs ATAN2

print "\n*** Illustrating Shadows PERL *** hDial Jan 5, 2014\n";

print "\nEnter a latitude as nn.n   ";
$latitude = readline(*STDIN);

print "\nEnter a longitude offset (+ is west, - is east) as nn.n    ";
$longitude = -readline(*STDIN);

$slat = sin($latitude*2*3.14159/360);

$hr=-6;
while ($hr<7) {                              # NOTE: ctrl-C will break a loop in Windows 8
    
    # following does not need "use Math::Trig;" however, it is needed for ATAN etc
    # $hlaTAN = $slat ;
    # $hlaTAN = $hlaTAN * sin(15*($hr+($longitude*4/60)))*2*3.14159/360) ;
    # $hlaTAN = $hlaTAN / cos(15*($hr+($longitude*4/60)))*2*3.14159/360) ;

    $hlaTAN = $slat * Math::Trig::tan(15*($hr+($longitude*4/60))*2*3.14159/360);

    $hla    = atan($hlaTAN);                 # needs "use Math::Trig;" as "atan2" is worthless
    $hla    = $hla*360/(2*3.14159);

    # http://alvinalexander.com/blog/post/perl/reference-page-perl-printf-formatting-format-cheat-sheet
    print "\nhour is: " , $hr+12 ," hour line angle is: ";    
    printf("%.2f", $hla);

    $hr = $hr + 1;
}

print "\nbye.\n";
$latitude = readline(*STDIN);               # any old input to pause screen
# end #
