# A vertical sundial with a longitude correction, text only
# www.illustratingshadows.com               # January 5, 2013
# converted from the hDial Perl program, see ... "# change here for h->v Dial" notes

use English;
#                                           # http://perldoc.perl.org/Math/Trig.html#TRIGONOMETRIC-FUNCTIONS
use Math::Trig;                             # needs "use Math::Trig;" as "atan2" is worthless
                                            # also TAN is in math.trig, otherwise you must
                                            # do sin/cos. But the big deal is TAN vs ATAN2

print "\n*** Illustrating Shadows PERL *** vDial Jan 5, 2014\n";

print "\nEnter a latitude as nn.n   ";
$latitude = 90-readline(*STDIN);            # changed to co-latitude

print "\nEnter a longitude offset (+ is west, - is east) as nn.n    ";
$longitude =  readline(*STDIN);             # remove "-" as moving from h->vDial

$slat = sin($latitude*2*3.14159/360);

$hr=6;                                      # change here for h->v Dial
while ($hr>-7) {                            # change here for h->v Dial
    
    # following does not need "use Math::Trig;" however, it is needed for ATAN etc
    # $hlaTAN = $slat ;
    # $hlaTAN = $hlaTAN * sin(15*($hr+($longitude*4/60)))*2*3.14159/360) ;
    # $hlaTAN = $hlaTAN / cos(15*($hr+($longitude*4/60)))*2*3.14159/360) ;

    $hlaTAN = $slat * Math::Trig::tan(15*($hr+($longitude*4/60))*2*3.14159/360);

    $hla    = atan($hlaTAN);                # needs "use Math::Trig;" as "atan2" is worthless
    $hla    = $hla*360/(2*3.14159);

    # http://alvinalexander.com/blog/post/perl/reference-page-perl-printf-formatting-format-cheat-sheet
    print "\nhour is: " , 12-$hr ," hour line angle is: ";   # change here for h->v Dial  
    printf("%.2f", -$hla);                  # change here for h->v Dial 

    $hr = $hr - 1;                          # change here for h->v Dial
}

print "\nbye.\n";
$latitude = readline(*STDIN);               # any old input to pause screen
# end #